/*
 * Copyright 2015 The original authors.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package io.sundr.codegen.generator;

import io.sundr.builder.Builder;

public class CodeGeneratorBuilder<M> extends CodeGeneratorFluent<M, CodeGeneratorBuilder<M>> implements Builder<CodeGenerator> {

    public CodeGeneratorBuilder() {
    }
    
    public CodeGeneratorBuilder(CodeGenerator<M> instance) {
        withModel(instance.getModel());
        withParameters(instance.getParameters());
        withWriter(instance.getWriter());
        withTemplateResource(instance.getTemplateResource());
        withTemplateContent(instance.getTemplateContent());
        withTemplateUrl(instance.getTemplateUrl());
        withDirectives(instance.getDirectives());
    }
    
    public CodeGenerator build() {
       return new CodeGenerator(getContext(),  getModel(), getParameters(), getWriter(), getTemplateUrl(), getTemplateResource(), getTemplateContent(), getDirectives() );
    }
}