/*
 *      Copyright 2019 The original authors.
 *
 *      Licensed under the Apache License, Version 2.0 (the "License");
 *      you may not use this file except in compliance with the License.
 *      You may obtain a copy of the License at
 *
 *          http://www.apache.org/licenses/LICENSE-2.0
 *
 *      Unless required by applicable law or agreed to in writing, software
 *      distributed under the License is distributed on an "AS IS" BASIS,
 *      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *      See the License for the specific language governing permissions and
 *      limitations under the License.
 */

package io.sundr.codegen.model;

public class ModifierSupportFluentImpl<A extends ModifierSupportFluent<A>> extends AttributeSupportFluentImpl<A> implements ModifierSupportFluent<A>{

    private int modifiers;

    public ModifierSupportFluentImpl(){
    }
    public ModifierSupportFluentImpl(ModifierSupport instance){
            this.withModifiers(instance.getModifiers()); 
            this.withAttributes(instance.getAttributes()); 
    }

    public int getModifiers(){
            return this.modifiers;
    }

    public A withModifiers(int modifiers){
            this.modifiers=modifiers; return (A) this;
    }

    public Boolean hasModifiers(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ModifierSupportFluentImpl that = (ModifierSupportFluentImpl) o;
            if (modifiers != that.modifiers) return false;
            return true;
    }




}
